uses Objects, App, DAE, Views, DBWind, cmdbview, Menus, Drivers, Ext_Str,
     GadGets, DBT_Unit, FPT_Unit, Memory, Ext_Clp, Ext_Win, Dialogs,
     Editors, ResTools, Ext_Crt, MsgBox, Ext_Sys, HelpFile, Ext_Dos,
     s_DBView, Ext_App, Dos, Clases, TabNotbk, AddCntrl, HistList,
     StdDlg, MultiSel, Ext_Math, DBV_HLP, ColorSel, VMM, Validate,
     CreatDBF, DBW_type, DBCtrls, Register;

{$IFDEF WIN32}
{$R DBVIEWS.RES}
{$ENDIF}

{$IFDEF VER70}
const
  HeapSize = 170 * (1024 div 16);
{$ENDIF}

function DBErrorProc( Code:TErrorCode;var Info):word;far;
var
  S:string;
begin
  S:=GetString(byte(Code)+2500);
  if S='' then S:=GetString(2500);
  if Code = edbDataSetNotClosed then PrintStr(S)
  else MessageBox(S, @Info, mfError+mfOkButton);
  HasError:=true;
end;

type
  TDBViews = object(TApplication)
    Clock:PClockView;
    ScrSavDelay:Longint;
    OldSec:word;
    FileName:FNameStr;
    ReadOnly:boolean;
    constructor Init;
    destructor Done;virtual;
    procedure InitStatusLine;virtual;
    procedure Idle;virtual;
    procedure GetEvent(var Event: TEvent);virtual;
    procedure OutOfMemory; virtual;
    function GetPalette: PPalette; virtual;
    function GetHelpCtx: Word; virtual;
    procedure ParseParamLine;
    procedure ReadDesktop;
    procedure WriteDesktop;
  end;

{ TDBViews }
constructor TDBViews.Init;
var
  R: TRect;
  S:string;
begin
  RegisterViews;
  RegisterDialogs;
  RegisterHelpFile;
  RegisterClases;
  RegisterTabNotbk;
  RegisterType(RRangeILine);
  RegisterType(RHCStatusLine);
  RegisterMenus;
  RegisterType(RFileInputLine);
  RegisterType(RFileCollection);
  RegisterType(RFileList);
  RegisterType(RFileInfoPane);
  RegisterType(RFileDialog);
  RegisterType(RColorText);
  RegisterType(RDBEdit);
  RegisterType(ROkListBox);
  RegistersMultiSelect;
  RegisterColorSel;
  RegisterValidate;
  RegisterAll;
  {$IFDEF VER70}
  MaxHeapSize:=HeapSize;
  {$ENDIF}
  DBError:=DBErrorProc;
  isMultiUser:=not ExclusiveMode;
  LoadLocaleInformation;
  DBError:= DBErrorProc;
  InitDataSets;
  PrintStr(GetString(sCopyright));
  SaveScreen;
  inherited Init;
  S:=#$30#$38#$34#$20#$28#$24#$17#$1B;
  Move(S[1],Application^.GetPalette^[2], Length(S));
  Application^.GetPalette^[65]:=#$1B;
  DisableCommands([cmHiLoRange]);
  {$IFDEF VER70}
  case InitClipboard of
    1:InitTVClipboard;
    2:InitWinClp;
  end;
  if (InitClipboard<>0) and (Clp=nil) then InitSingleClp;
  {$ELSE}
  InitWinClp;
  {$ENDIF}
  GetExtent(R);
    R.A.X := R.B.X - 9; R.B.Y := R.A.Y + 1;
    Clock := New(PClockView, Init(R));
    Clock^.GrowMode:=gfGrowLoX+gfGrowHiX;
    Insert(Clock);
  R.Move(-15,0);
  Inc(R.B.X,5);
  RecPosStatus:=Insert(New(PStaticText, Init(R, '')));
  RecPosStatus^.OnMouseEvent:=RecPosStatusMouseEvent;
  RecPosStatus^.EventMask:=RecPosStatus^.EventMask or evMouseDown;
  R.Move(-10,0);
  Dec(R.B.X,5);
  IndexStatus:=Insert(New(PStaticText, Init(R, GetString(sIndexedText))));
  IndexStatus^.Hide;
  R.Move(-10,0);
  DelStatus:=Insert(New(PStaticText, Init(R, GetString(sDeletedText))));
  DelStatus^.Hide;
  ReadDesktop;
end;

destructor TDBViews.Done;
begin
  StoreIniFile;
  WriteDesktop;
  inherited Done;
  RestoreScreen;
  DoneDataSets;
  DoneClipboard;
  DoneTVRFile;
end;

function TDBViews.GetHelpCtx: Word;
var W:word;
begin
  W:=inherited GetHelpCtx;
  if W=hcList then
     W:=GetShiftState and $0F + hcList;
  GetHelpCtx:=W;
end;

function TDBViews.GetPalette: PPalette;
const
  CNewColor = CAppColor + CHelpColor;
  CNewBlackWhite = CAppBlackWhite + CHelpBlackWhite;
  CNewMonochrome = CAppMonochrome + CHelpMonochrome;
  P: array[apColor..apMonochrome] of string[Length(CNewColor)] =
    (CNewColor, CNewBlackWhite, CNewMonochrome);
begin
  GetPalette := @P[AppPalette];
end;

procedure TDBViews.OutOfMemory;
begin
  RMessageBox(sNoMem, nil, mfError + mfOKButton);
end;

procedure TDBViews.GetEvent(var Event: TEvent);
var
  W: PView;
  HFile: PHelpFile;
  HelpStrm: PDosStream;
const
  HelpInUse: Boolean = False;

procedure HelpWin;

function MakeHWindow:PView;
begin
  MakeHWindow:=nil;
  HelpStrm:=New(PDosStream,Init(CalcFileName(EXEName,GetString(sHelpFileName)),stOpenRead));
  HFile := New(PHelpFile, Init(HelpStrm));
  if HelpStrm^.Status <> stOk then
  begin
     RMessageBox(sErrorHelp, nil, mfError + mfOkButton+mfInsertInApp);
     Dispose(HFile, Done);
     exit;
  end
  else
    MakeHWindow:= New(PHelpWindow,Init(HFile, GetHelpCtx));
end;

begin
  if not HelpInUse then
  begin
    HelpInUse := True;
    W:=MakeHWindow;
    if W<>nil then
    begin
      ExecView(W);
      W^.Free;
    end;
    HelpInUse := False;
  end;
  ClearEvent(Event);
end;
begin
  inherited GetEvent(Event);
  if (Event.What = evCommand) and (Event.Command = cmHelp) then HelpWin;
  isWait:=Event.What=evNothing;
end;

procedure TDBViews.Idle;
var
  h,m,s,hund: word;
begin
  inherited Idle;
  Clock^.Update;
  Message(Application, evBroadcast, cmIdle, nil);
  if UseScreenSaver then
     if isWait then
     begin
       GetTime(h,m,s,hund);
       if OldSec<>S then
       begin
         Inc(ScrSavDelay);
         OldSec:=S;
       end;
       if ScrSavDelay>IntervelScreenSaver*60 then
       begin
          ScrSaver('*'#15,5);
          isWait:=false;
       end;
     end
     else
     begin
       isWait:=true;
       ScrSavDelay:=0;
     end;
end;

procedure TDBViews.InitStatusLine;
var R:TRect;
begin
  Application^.GetExtent(R);
  R.A.Y:=R.B.Y-1;
  StatusLine:=GetView(sStatusLine);
  StatusLine^.SetBounds(R);
end;

procedure TDBViews.ReadDesktop;
var
  S:PDosStream;
  Sign:string;
  Pal: PString;
  Signature:string;
  DSKFile:FNameStr;
begin
  DSKFile:=ExePath+Ext_Dos.ExeName+'.dsk';
  if not FileExists(DSKFile) then exit;
  Signature:=GetString(sSignature);
  S:=New(PDosStream, Init(DSKFile, stOpen));
  if S^.Status=stOk then
  begin
    Sign[0]:=char(Length(Signature));
    S^.Read(Sign[1], Length(Signature));
    if Sign<>Signature then
       RMessageBox(sDeskInvalid, nil, mfOkButton+mfError)
    else
    begin
      LoadHistory(S^);
      Pal := S^.ReadStr;
      if Pal <> nil then
      begin
        Application^.GetPalette^ := Pal^;
        DoneMemory;
        Application^.ReDraw;
        DisposeStr(Pal);
      end;
      if S^.Status<>stOk then
         RMessageBox(sErrorReadingDesk, nil, mfOkButton+mfError);
    end;
  end
  else RMessageBox(sErrorOpenDesk, nil, mfOkButton+mfError);
  S^.Free;
end;

procedure TDBViews.WriteDesktop;
var
  S:PDosStream;
  Pal: PString;
  Dir:DirStr;
  Name: NameStr;
  Ext: ExtStr;
  Signature:string[23];
  P:PCollection;
begin
  Signature:=GetString(sSignature);
  S:=New(PDosStream, Init(ExePath+Ext_Dos.ExeName+'.dsk', stCreate));
  if S^.Status=stOk then
  begin
    S^.Write( Signature[1], Length(Signature));
    StoreHistory(S^);
    Pal := @Application^.GetPalette^;
    S^.WriteStr(Pal);
    if S^.Status<>stOk then RMessageBox(sErrorWriteDSK, nil, mfOkButton+mfError);
  end
  else RMessageBox(sErrorDeskCreate, nil, mfOkButton+mfError);
  S^.Free;
end;

procedure TDBViews.ParseParamLine;
var I:integer;
    S:string;
begin
  for i:=1 to ParamCount do
  begin
    S:=Trim(ParamStr(i));
    if S[1] in ['-','/'] then ReadOnly:=S[2] in ['R','r']
    else FileName:=FullName(ReplaceExt(S,'.dbf',false));
  end;
end;


var
  DBV:TDBViews;
  P:PString;
  S:string;
  f:file;
begin
  RegisterObjects;
  RegisterType(RStringList);
  LoadIniFile;
  InitTvrFile(ExePath+LngName);
  ResourseStrings := PStringList(ResourseFile.Get('Strings'));
  if (ParamCount>0) or RunEmptyCMD then
  begin
    DBV.Init;
    P:=@DBV.FileName;
    if ParamCount=0 then
    begin
      if RExecDialog(sDbfOpenDlg,P)=cmCancel then
      begin
        DBV.Done;
        Halt(1);
      end;
    end
    else DBV.ParseParamLine;

    if not FileExists(DBV.FileName) then
    if RMessageBox(sFileNotFoundCreate,@P, mfConfirmation+mfYesNo)=cmYes then
       CreateDataBase(DBV.FileName);
    if FileExists(DBV.FileName) then
    begin
      DBV.InsertWindow(New(PDBWindow, Init(DBV.FileName, DBV.ReadOnly)));
      if DBWindow<>nil then DBV.Run;
    end;
    DBV.Done;
  end
  else
  begin
    PrintStr(GetString(sCopyrightError));
    DoneTVRFile;
  end
end.
