{$I Define.inc}
uses Objects, ResTools, DAE, Ext_Dos, s_DBView, TabNotbk, Dialogs, Views,
     Clases, AddCntrl, Menus, Drivers, cmdbview, App, StdDlg, MultiSel,
     DBV_HLP, ColorSel, Validate, CreatDBF, DBW_type, DBCtrls, Register,
     Ext_Str, Ext_Math, Std_Str, SelFUnit;

const
  BuildNo : Longint = 0;
  Vers    = '1.5 beta 3';
{$IFDEF OS_DOS}
  OS_NAME = ' (DOS)';
{$ELSE}
{$IFDEF WIN32}
  OS_NAME = ' (Win32)';
{$ELSE}
  OS_NAME = 'other';
{$ENDIF}
{$ENDIF}

procedure CreateStrings;
var
  S: PStrListMaker;
  K:TErrorCode;
begin
  S := New(PStrListMaker, Init(32000, 1000));
  with S^ do
  begin
    Put(sLanguage,    {$IFDEF RUS}'᪨'
                   {$ELSE}'English'{$ENDIF});
    Put(sHelpFileName, {$IFDEF RUS}'DBV_RUS.HLP'
                   {$ELSE}'DBV_HLP.HLP'{$ENDIF});
    Put(sNoMem,        {$IFDEF RUS}'墠⠥   믮 樨'
                   {$ELSE} 'Not enough memory available to compilete operation.'{$ENDIF});
    Put(sErrorReading, {$IFDEF RUS} '訡 ⥭ 䠩 %s.'
                   {$ELSE}'Error reading file %s.'{$ENDIF});
    Put(sErrorWriting, {$IFDEF RUS} '訡  䠩 %s'
                   {$ELSE}'Error writing file %s.'{$ENDIF});
    Put(sErrorCreating,{$IFDEF RUS} '訡 ᮧ 䠩 %s'
                   {$ELSE} 'Error creating file %s.'{$ENDIF});
    Put(sStrNotFound,  {$IFDEF RUS} '᪮ ப  .'
                   {$ELSE}'Search string not found.'{$ENDIF});
    Put(sErrorHelp,    {$IFDEF RUS} '  䠩 .'
                   {$ELSE}'Could not open help file.'{$ENDIF});
    Put(sErrorOpenDesk,{$IFDEF RUS} '  䠩 ஥'
                   {$ELSE} 'Could not open desktop file.'{$ENDIF});
    Put(sErrorReadingDesk,{$IFDEF RUS}'訡 ⥭ 䠩 ஥.'
                   {$ELSE} 'Error reading desktop file.'{$ENDIF});
    Put(sErrorWriteDSK,{$IFDEF RUS}'  䠩 ஥.'
                   {$ELSE}'Could not write desktop file.'{$ENDIF});
    Put(sErrorDeskCreate,{$IFDEF RUS}' ᮧ 䠩 ஥.'
                   {$ELSE}'Could not create desktop file.'{$ENDIF});
    Put(sDeskInvalid,  {$IFDEF RUS}'訡: ७ ଠ 䠩 ஥'
                   {$ELSE}'Error: Invalid Desktop file.'{$ENDIF});
    Put(sCopyright,      {$IFDEF RUS}'DBVIEWS  '+Vers+OS_NAME+', ࠡ⪠ (C) 1999-'+IntToStr(CurrentYear)+
                                        ' 㭮 ..'#13#10+
                                        'ઠ '+IntToStr(BuildNo)+'  '+DateToStr(Date)+'.'#13#10
                   {$ELSE}'DBVIEWS version '+Vers+OS_NAME+', Copyright (C) 1999-'+IntToStr(CurrentYear)+
                          ' by Lagunov A.A.'#13#10+
                          'Build '+IntToStr(BuildNo)+' from '+DateToStr(Date)+'.'#13#10
                   {$ENDIF});
    Put(sCopyrightError,{$IFDEF RUS}'DBVIEWS  '+Vers+OS_NAME+', ࠡ⪠ (C) 1999-'+IntToStr(CurrentYear)+
                         '  㭮 ..'#13#10+
                         'ઠ '+IntToStr(BuildNo)+'  '+DateToStr(Date)+'.'#13#10+
                         'ᯮ짮: DBVIEWS [-R[eadOnly]]<>'#13#10
                   {$ELSE}'DBVIEWS  '+Vers+OS_NAME+', Copyright (C) 1999-'+IntToStr(CurrentYear)+
                        ' by Lagunov A.A.'#13#10+
                        'Build '+IntToStr(BuildNo)+' from '+DateToStr(Date)+'.'#13#10+
                        'Usage: DBVIEWS [-R[eadOnly]] <FileName>'#13#10{$ENDIF});
    Put(sSignature,     'DBViews desktop file'#26);
    Put(sConfirmDelete,{$IFDEF RUS} ' ⢨⥫쭮  㤠 ?'
                   {$ELSE} 'Are you shure delete record?'{$ENDIF});
    Put(sConfirmRecal, {$IFDEF RUS} ' ⢨⥫쭮  ⠭ ?'
                   {$ELSE} 'Are you shure recal record?'{$ENDIF});
    Put(sConfirmAppend,{$IFDEF RUS} ' ⢨⥫쭮   ?'
                   {$ELSE} 'Are you shure append record?'{$ENDIF});
    Put(sConfirmPack,  {$IFDEF RUS} ' ⢨⥫쭮  㯠 ⠡?'
                   {$ELSE}'Are you shure pack table?'{$ENDIF});
    Put(sTargetDTW,    {$IFDEF RUS} '  ࠭ 866 (Dos)   ࠭ 1251 (Win)?'
                   {$ELSE}'Change code page 866 (DOS) to code page 1251 (Windows)?'{$ENDIF});
    Put(sTargetWTD,    {$IFDEF RUS} '  ࠭ 1251 (Win)   ࠭ 866 (Dos)?'
                   {$ELSE}'Change code page 1251 (Windows) to code page 866 (DOS)?'{$ENDIF});
    Put(sConfirmEmpty, {$IFDEF RUS} ' ⢨⥫쭮   ⠡?'
                   {$ELSE}'Are you shure empty table?'{$ENDIF});
    Put(sFieldNotSum,  {$IFDEF RUS} '⮬    㬬஢.'
                   {$ELSE}'This field not summed.'{$ENDIF});
    Put(sFieldSum,     {$IFDEF RUS} ^C'㬬  ⮬  ࠢ '^M^C'''%s''.'
                   {$ELSE}^C'Sum for this field '^M^C'''%s''.'{$ENDIF});
    Put(sDBaseIIIComp,{$IFDEF RUS} 'DBase III ᮢ⨬.'
                   {$ELSE}'DBase III compotable'{$ENDIF});
    Put(sDos, 'Dos');
    Put(sWindows,'Windows');
    Put(sWaitProgres,  {$IFDEF RUS} '   - %s. 믮 %3d%%.'
                   {$ELSE}'Processing %s. Complete %3d%%.'{$ENDIF});
    Put(sFileNameStru, {$IFDEF RUS} ' 䠩 %s.'
                   {$ELSE} '%s file strucure.'{$ENDIF});
    Put(sReload,       {$IFDEF RUS} ' 묥 ᨫ ⮫쪮 १㧪 DBViews.'
                   {$ELSE}'Changes do not take effect until you reload the DBViews.'{$ENDIF});
    Put(sSaveHead1,       {$IFDEF RUS} '        '
                   {$ELSE}'Name       '{$ENDIF});
    Put(sSaveHead2,       {$IFDEF RUS} ''
                   {$ELSE}'Typ'{$ENDIF});
    Put(sSaveHead3,       {$IFDEF RUS} ''
                   {$ELSE}'Len  '{$ENDIF});
    Put(sSaveHead4,       {$IFDEF RUS} '.'#13#10
                   {$ELSE}'Dec.'#13#10{$ENDIF});
    Put(sSaveHead5,'NN  ');
    Put(sFileNotFoundCreate,{$IFDEF RUS}' ''%s''  .  ?'
                   {$ELSE}'File ''%s'' not found. Create?'{$ENDIF});
    Put(sRecordCount,{$IFDEF RUS}'饬 ᫮ ᮮ⢥ %d ᥩ.'
                   {$ELSE}'Curent range contanse %d records.'{$ENDIF});
    Put(sOk,strOk);
    Put(sYes,strYes);
    Put(sNo,strNo);
    Put(sCancel,strCancel);
    Put(sWarningStr,{$IFDEF RUS}'।०'{$ELSE}'Warning'{$ENDIF});
    Put(sErrorStr,{$IFDEF RUS}'訡'{$ELSE}'Error'{$ENDIF});
    Put(sInfoStr,{$IFDEF RUS}'ଠ'{$ELSE}'Information'{$ENDIF});
    Put(sConfirmStr,{$IFDEF RUS}'⢥ত'{$ELSE}'Confirmation'{$ENDIF});
    Put(sHelpStr,{$IFDEF RUS}'~~'{$ELSE}'~H~elp'{$ENDIF});
    Put(sMemoEdit, {$IFDEF RUS}'ଥ砭...('{$ELSE}'Memo editor...('{$ENDIF});
    Put(sDOSText,'DOS ⥪');
    Put(sDeletedText,{$IFDEF RUS}^C''{$ELSE}^C'Deleted'{$ENDIF});
    Put(sIndexedText,{$IFDEF RUS}^C''{$ELSE}^C'Indexed'{$ENDIF});
    Put(sRecordNotFound, {$IFDEF RUS}'  '{$ELSE}'Records not found'{$ENDIF});
    Put(sNotImplemented,{$IFDEF RUS}^C' 㭪   ᮦ'^M' ॠ...'^M'.'
                        {$ELSE}^C'This function is not'^M' yet implemented...'^M'Sorry.'{$ENDIF});
    Put(sNotValidTable,^C' ࠧ ⠡.  ⠡ %d ᥩ.'+
         '  㪠 %d ᥩ. ࠢ ?');
    Put(sArifmeticProgressError,{$IFDEF RUS}'䬥᪠ ண  ⮫쪮  ᫮ '{$ELSE}
          'Arifmetic progression only for numeric fields.'{$ENDIF});
    {-----Don't translate this text--------}

    Put(sOptionsDlg,'OptionsDlg');
    Put(sStatusLine,'StatusLine');
    Put(sLocalMenu,'LocalMenu');
    Put(sFileStruDlg,'FileStruDlg');
    Put(sSavePrnFile,'SavePrnFile');
    Put(sPrintDlg,'PrintDlg');
    Put(sAbout,'About');
    Put(sFindForm, 'FindForm');
    Put(sGoForm,'GoForm');
    Put(sDirectFieldEditor,'DirectFieldEditor');
    Put(sCopyStruct,'CopyStruct');
    Put(sIndexExpresDlg,'IndexExpresDlg');
    Put(sColorDlg, 'ColorDlg');
    Put(sNewDBFieldDialog,'NewDBFieldDialog');
    Put(sCreateTableDialog,'CreateTableDialog');
    Put(sDBFCreateDialog,'DBFCreateDialog');
    Put(sRangeDialog,'RangeDialog');
    Put(sReplaseForm,'ReplaseForm');
    Put(sFilterForm,'FilterForm');
    Put(sSelectLng,'SelectLng');
    Put(sDbfOpenDlg, 'DbfOpenDlg');
    Put(sSelectLngForDLG,'SelectLngForDLG');
    Put(sArifmetForm,'ArifmetForm');
    Put(sSelFForm,'SelFForm');

  {---------------------}
    Put(hcAppendRec,{$IFDEF RUS} '  '
                   {$ELSE}'Append new record'{$ENDIF});
    Put(hcEditRec,{$IFDEF RUS} '஢ ⥪ '
                   {$ELSE}'Edit curent record'{$ENDIF});
    Put(hcDelRec,{$IFDEF RUS} '  㤠  /  '
                   {$ELSE}'Mark "Delete" curent record / Recal deleted record'{$ENDIF});
    Put(hcFindRec,{$IFDEF RUS} '᪠ '
                   {$ELSE}'Find records'{$ENDIF});
    Put(hcGoRecordNum,{$IFDEF RUS} '   ..'
                   {$ELSE}'Go record number..'{$ENDIF});
    Put(hcViewStru,{$IFDEF RUS} 'ᬮ  ⥪饩 ⠡'
                   {$ELSE}'View structure of curent table'{$ENDIF});
    Put(hcDosWin,{$IFDEF RUS} 'ᬮ  DOS  Windows ஢'
                   {$ELSE}'View in DOS-(866) or WINDOWS (1251) codepage'{$ENDIF});
    Put(hcSpechial,{$IFDEF RUS} '樠    '
                   {$ELSE}'Speshial commands for database'{$ENDIF});
    Put(hcIndexExpresi,{$IFDEF RUS} ' ᫮   ࠦ  ஢ ⠡'
                   {$ELSE}'Enter index expresion for sort table'{$ENDIF});
    Put(hcPack,{$IFDEF RUS} ' , 祭  㤠'
                   {$ELSE}'Delete marked records from database'{$ENDIF});
    Put(hcEmpty,{$IFDEF RUS} ' ⠡'
                   {$ELSE}'Empty current table'{$ENDIF});
    Put(hcCopyStru,{$IFDEF RUS} '஢  ⠡  㣮 䠩'
                   {$ELSE}'Copy structure of this table to another table'{$ENDIF});
    Put(hcSpeshDel,{$IFDEF RUS} ' , 㤮⢮騥 ᫮'
                   {$ELSE}'Delete rocord from table with expresion'{$ENDIF});
    Put(hcChCP,{$IFDEF RUS} '  ࠭ ⠡ (DOS<-->WINDOWS)'
                   {$ELSE}'Change codepage curent table (DOS<-->WINDOWS)'{$ENDIF});
    Put(hcDirectEdit,{$IFDEF RUS} 'אַ ।஢ '
                   {$ELSE}'Direct edit value of curent field'{$ENDIF});
    Put(hcStatFunc,{$IFDEF RUS} '᪨  㣨 㭪樨'
                   {$ELSE}'Statistic and misk functions..'{$ENDIF});
    Put(hcSumField,{$IFDEF RUS} '᫨ 㬬  '
                   {$ELSE}'Calc sum for field'{$ENDIF});
    Put(hcCountRec,{$IFDEF RUS} ' ⢮ ᥩ  '
                   {$ELSE}'Display count records for you query'{$ENDIF});
    Put(hcPrint,{$IFDEF RUS} '   ⥪饩 ⠡'
                   {$ELSE}'Print data from record curent table'{$ENDIF});
    Put(hcOptions,{$IFDEF RUS} '⠭ ⥬, ࠬ   '
                   {$ELSE}'Set default system, viewing and etc'{$ENDIF});
    Put(hcScreenSaver,{$IFDEF RUS}' ணࠬ ࠭ ࠭ ᫥  ࢠ'
                   {$ELSE}'Run screen saver after the inactivity interval in minutes'{$ENDIF});
    Put(hcRunEmptyCMD,{$IFDEF RUS}' ணࠬ  ⮩  ப'
                   {$ELSE}'Run DBViews whith empty command line'{$ENDIF});
    Put(hcAutoRefresh,{$IFDEF RUS}' Win32 ᨨ ᫥  DBF 䠩 譨 ᠬ'
                   {$ELSE}'In Win32 version track chenges of curent DBF file'{$ENDIF});
    Put(hcAbout,      {$IFDEF RUS} ' ଠ  ᨨ  ᪨ ࠢ'
                   {$ELSE}'Show version and copyright information'{$ENDIF});
    Put(hcAboutDlg,    {$IFDEF RUS}'   ᬮ  .  Enter  '
                   {$ELSE}'Welcome to database viewer. Press Enter to close this dialog box'{$ENDIF});
    Put(hcDLGIndexExp,{$IFDEF RUS}' ᭮ ࠦ  㯮冷稢 ⠡'
                   {$ELSE}'Enter the index expresion for sort table'{$ENDIF});
    Put(hcDLGFind,    {$IFDEF RUS}' ⥪  ᪠  ⠡'
                   {$ELSE}'Enter text to find in table'{$ENDIF});
    Put(hcExclusiveFile,{$IFDEF RUS}' ०  䠩  '
                   {$ELSE}'Excluzive mode open date file'{$ENDIF});
    Put(hcSel_Lang,{$IFDEF RUS}'롮 몠 䥩'
                   {$ELSE}'Select inteface language'{$ENDIF});
    Put(hcMFilter,{$IFDEF RUS}'᫮ 䨫樨 '
                   {$ELSE}'Filter expresion for view records'{$ENDIF});
    Put(hcMIndexRange,{$IFDEF RUS}'࠭ ⮡ࠦ '
                   {$ELSE}'Index range for view records'{$ENDIF});
    Put(hcMCancelRange,{$IFDEF RUS}' ࠭ ⮡ࠦ'
                   {$ELSE}'Cancel index range'{$ENDIF});
    Put(hcMOptions,{$IFDEF RUS}' ன ࠬ஢, 梥⮢  .'
                   {$ELSE}'Set defaults for drivers, viewers, etc.'{$ENDIF});
    Put(hcMColors,{$IFDEF RUS}'ன 梥⮢ '
                   {$ELSE}'Specify editor settings'{$ENDIF});

    {Standert DAE error messages}

    for k:=edbNoError to High(TErrorCode) do
        Put(2500+byte(k),StdErrorNames(k));
  end;
(*  Put(,    {$IFDEF RUS}
                 {$ELSE}''{$ENDIF});
    Put(,    {$IFDEF RUS}
                 {$ELSE}{$ENDIF});*)

  ResourseFile.Put(S, 'Strings');
  Dispose(S, Done);
end;

procedure CreateStatusLine;
var
  R: TRect;
  P: PView;
begin
  R.Assign(0, 0, 80, 1);
  P:=New(PHCStatusLine, Init(R,
    NewStatusDef(0, hcList,
      NewStatusKey('~ESC~ '+{$IFNDEF RUS}'Exit'{$ELSE}'室'{$ENDIF}, kbAltX, cmQuit,
      NewStatusKey('~F4~ '+{$IFNDEF RUS}'Mode'{$ELSE}''{$ENDIF}, kbF4, cmFormView,
      NewStatusKey({$IFNDEF RUS}'~F5~ Go'{$ELSE}'~F5~ '{$ENDIF}, kbF5, cmGoRec,
      NewStatusKey({$IFNDEF RUS}'~F6~ Sort'{$ELSE}'~F6~ '{$ENDIF}, kbF6, cmSortRecords,
      NewStatusKey({$IFNDEF RUS}'~F7~ Find'{$ELSE}'~F7~ ᪠'{$ENDIF}, kbF7, cmFindRec,
      NewStatusKey({$IFNDEF RUS}'~F8~ Del/Rec'{$ELSE}'~F8~ /'{$ENDIF}, kbF8, cmDeleteRecal,
      NewStatusKey({$IFNDEF RUS}'~F9~ Print'{$ELSE}'~F9~ '{$ENDIF}, kbF9, cmPrint,
      NewStatusKey({$IFNDEF RUS}'~F10~ Menu'{$ELSE}'~F10~ '{$ENDIF}, kbF10, cmLocalMenu,
      NewStatusKey('', kbF3, cmQuit,
      NewStatusKey('', kbF2, cmEdit,
      NewStatusKey('', kbF1, cmHelp,
      StdStatusKeys(nil)))))))))))),
    NewStatusDef(hcList+1, hcList+3,
      NewStatusKey('~Shift~ +', kbNoKey, cmError,
      NewStatusKey('~F3~ '+{$IFNDEF RUS}'Struct'{$ELSE}''{$ENDIF}, kbShiftF3, cmViewStru,
      NewStatusKey('~F4~ '+{$IFNDEF RUS}'Editor'{$ELSE}''{$ENDIF}, kbShiftF4, cmDirectEdit,
      NewStatusKey('~F6~ '+{$IFNDEF RUS}'Ind.expres'{$ELSE}'.ࠦ.'{$ENDIF}, kbShiftF6,cmIndExpr,
      NewStatusKey('~F7~ '+{$IFNDEF RUS}'More'{$ELSE}''{$ENDIF}, kbShiftF7,cmFindMore,
      NewStatusKey('~F8~ Dos/Win', kbShiftF8, cmCodePage,
      StdStatusKeys(nil))))))),
    NewStatusDef(hcList+4, hcList+7,
      NewStatusKey('~Ctrl+'#$18#$19#$1A#$1B'~ '+{$IFNDEF RUS}+'Resize collumn'{$ELSE}' ⮫殢'{$ENDIF},
                            kbNoKey, cmError,
      NewStatusKey('~Ctrl+F6~ Range', kbCtrlF6, cmHiLoRange,
      NewStatusKey('~F7~ '+{$IFNDEF RUS}'Filter'{$ELSE}''{$ENDIF}, kbCtrlF7,cmFilter,
      NewStatusKey('~Ctrl+F8~ CP Tables', kbCtrlF8, cmSelectLngDlg,
      StdStatusKeys(nil))))),
    NewStatusDef(hcList+8, hcList+15,
      NewStatusKey('~Alt~ +', kbNoKey, cmError,
      NewStatusKey('~F3~ '+{$IFNDEF RUS}+'E~x~it'{$ELSE}'~~'{$ENDIF}, kbAltF3, cmQuit,
      NewStatusKey('~F5~ '+{$IFNDEF RUS}+'Console'{$ELSE}'࠭'{$ENDIF}, kbAltF5, cmUserScreen,
      NewStatusKey('~F6~ '+{$IFNDEF RUS}+'Cancel range'{$ELSE}' ࠭'{$ENDIF}, kbAltF6, cmCancelRange,
      NewStatusKey('', kbAltX, cmQuit,
      StdStatusKeys(nil)))))),
    NewStatusDef(hcEditField, hcEditField,
      NewStatusKey({$IFNDEF RUS}'~F1~ Help'{$ELSE}'~F1~ '{$ENDIF}, kbF1, cmHelp,
      NewStatusKey('~ESC~ '+{$IFNDEF RUS}+'Cancel'{$ELSE}'⬥'{$ENDIF}, kbNoKey, cmCancel,
      NewStatusKey('~Enter~ '+{$IFNDEF RUS}+'Save'{$ELSE}'࠭'{$ENDIF}, kbNoKey, cmOk,
      StdStatusKeys(nil)))),

    NewStatusDef(hcAppendRec, $FFFF,
      NewStatusKey({$IFNDEF RUS}'~F1~ Help'{$ELSE}'~F1~ '{$ENDIF}, kbF1, cmHelp,
      StdStatusKeys(nil)),
    nil))))))));
  ResourseFile.Put(P, 'StatusLine');
  Dispose(P, Done);

  P := New(PMenuPopup, Init(r,
       NewMenu(
         NewItem({$IFNDEF RUS}'Append'{$ELSE}'~~'{$ENDIF}, 'Ins', kbIns, cmAppend, hcAppendRec,
         NewItem({$IFNDEF RUS}'~E~dit'{$ELSE}'~~'{$ENDIF}, 'F2', kbF2, cmEdit, hcEditRec,
         NewItem({$IFNDEF RUS}'Delete/Recal'{$ELSE}'~~/⠭'{$ENDIF}, 'Del', kbDel, cmDeleteRecal, hcDelRec,
         NewItem({$IFNDEF RUS}'~F~ind...'{$ELSE}'~~...'{$ENDIF}, 'F7', kbF7, cmFindRec, hcFindRec,
         NewItem({$IFNDEF RUS}'~G~o record...'{$ELSE}'~~ ...'{$ENDIF}, 'F5', kbF5, cmGoRec, hcGoRecordNum,
         NewLine(
         NewSubMenu({$IFNDEF RUS}'~T~ools'{$ELSE}'~~㬥'{$ENDIF}, hcSpechial,
           NewMenu(
             NewItem({$IFNDEF RUS}'~I~nfo structure...'{$ELSE}'~~'{$ENDIF}, 'Shift+F3',
                                    kbShiftF3, cmViewStru, hcViewStru,
             NewItem('Dos/~W~indows', 'Shift+F8', kbShiftF8, cmCodePage, hcDosWin,
             NewItem('Codepage tables','Ctrl+F8', kbCtrlF8, cmSelectLngDlg, hcNoContext,
             NewItem({$IFNDEF RUS}'~I~ndex expresion...'{$ELSE}'~~᭮ ࠦ...'{$ENDIF}, 'Shift+F6',
                                                                            kbNokey, cmIndExpr, hcIndexExpresi,
             NewItem({$IFNDEF RUS}'Index ~r~ange...'{$ELSE}'࠭ '{$ENDIF},'Ctrl+F6',
                                                                            kbCtrlF6, cmHiLoRange, hcMIndexRange,
             NewItem({$IFNDEF RUS}'~C~ancel range'{$ELSE}' ࠭'{$ENDIF},'Alt+F6',
                                                                            kbAltF6, cmCancelRange, hcMCancelRange,
             NewItem({$IFNDEF RUS}'D~i~rect editor...'{$ELSE}'~~אַ ।஢'{$ENDIF}, 'Shift+F4',
                                                                            kbShiftF4, cmDirectEdit, hcDirectEdit,
             NewItem({$IFNDEF RUS}'~F~ilter...'{$ELSE}'~~...'{$ENDIF}, 'Shift+F7',
                                                                            kbShiftF7, cmFilter, hcMFilter,
             NewItem({$IFNDEF RUS}'~V~iew field...'{$ELSE}'~~  ᬮ'{$ENDIF}, '',
                                                                            kbNoKey, cmError, hcNoContext,
           nil)))))))))),
         NewSubMenu({$IFNDEF RUS}'~U~tilites'{$ELSE}'~~⨫'{$ENDIF}, hcSpechial,
           NewMenu(
             NewItem({$IFNDEF RUS}'~P~ack table...'{$ELSE}'~~'{$ENDIF}, '', kbNokey, cmPackTable, hcPack,
             NewItem({$IFNDEF RUS}'~E~mpty table...'{$ELSE}'~~'{$ENDIF}, '', kbNokey, cmEmptyTable, hcEmpty,
             NewItem({$IFNDEF RUS}'~C~opy structure...'{$ELSE}'~~ '{$ENDIF}, '', kbNokey, cmCopyStru, hcCopyStru,
             NewItem({$IFNDEF RUS}'S~p~eshial delete...'{$ELSE}'~~樠쭮 㤠'{$ENDIF}, '',
                                                                            kbNokey, cmQueryDelete, hcSpeshDel,
             NewItem({$IFNDEF RUS}'C~h~ange code page...'{$ELSE}' ~~஢'{$ENDIF}, '',
                                                                            kbNokey, cmChangeCodePage, hcChCP,
             NewItem({$IFNDEF RUS}'~F~ill records...'{$ELSE}'~~ ...'{$ENDIF}, '',
                                                                            kbNokey, cmFillRecords, hcCountRec,
             NewItem({$IFNDEF RUS}'~R~esort table...'{$ELSE}'~~஢ ⠡...'{$ENDIF}, '', kbNoKey, cmResortTable,
                                                                               hcNoContext,
             NewSubMenu({$IFNDEF RUS}'~E~xport...'{$ELSE}'ᯮ~~...'{$ENDIF}, hcSpechial,
               NewMenu(
                 NewItem({$IFNDEF RUS}'~E~xport to DIFF...'{$ELSE}'ᯮ~~  DIFF...'{$ENDIF}, '', kbNokey, cmExportToDIFF,
                          hcNoContext,
                 NewItem({$IFNDEF RUS}'Expo~r~t to SDF...'{$ELSE}'~~ᯮ  SDF...'{$ENDIF}, '', kbNokey, cmExportToSDF,
                          hcNoContext,
                 NewItem({$IFNDEF RUS}'Import from ~D~IFF...'{$ELSE}'  ~D~IFF...'{$ENDIF}, '', kbNokey,
                          cmImportFromDIFF, hcNoContext,
                 NewItem({$IFNDEF RUS}'Import from ~S~DF...'{$ELSE}'  ~S~DF...'{$ENDIF}, '', kbNokey, cmImportFromSDF,
                          hcNoContext,
               nil))))),
             NewItem({$IFNDEF RUS}'~P~rogression...'{$ELSE}'~~ண...'{$ENDIF}, '', kbNoKey,
                          cmArifmetProgres, hcNoContext,
             NewItem({$IFNDEF RUS}'~A~dd table...'{$ELSE}'~~ ⠡...'{$ENDIF}, '', kbNoKey,
                          cmAddTable, hcNoContext,
            nil))))
            ))))))),
         NewSubMenu({$IFNDEF RUS}'S~t~atistick'{$ELSE}'~~⨪'{$ENDIF}, hcStatFunc,
           NewMenu(
             NewItem({$IFNDEF RUS}'~S~umm for filed...'{$ELSE}'~~㬬  '{$ENDIF}, '', kbNokey, cmFieldSumm, hcSumField,
             NewItem({$IFNDEF RUS}'C~o~unt records...'{$ELSE}'~~⢮ ᥩ...'{$ENDIF}, '',
                                                                            kbNokey, cmRecordCount, hcCountRec,
             NewItem({$IFNDEF RUS}'Auto fills...'{$ELSE}'~~⮧...'{$ENDIF}, '',
                                                                            kbNokey, cmError, hcCountRec,
           nil)))),
         NewSubMenu({$IFNDEF RUS}'~V~iew'{$ELSE}'~~'{$ENDIF}, hcStatFunc,
           NewMenu(
             NewItem({$IFNDEF RUS}'~C~ollumn width...'{$ELSE}'~~ਭ '{$ENDIF}, '', kbAltF4, cmColWidth, hcNoContext,
             NewItem({$IFNDEF RUS}'C~o~unt records...'{$ELSE}'~~⢮ ᥩ...'{$ENDIF}, '',
                                                                            kbNokey, cmRecordCount, hcCountRec,
             NewItem({$IFNDEF RUS}'Auto fills...'{$ELSE}'~~⮧...'{$ENDIF}, '',
                                                                            kbNokey, cmError, hcCountRec,
           nil)))),
         NewLine(
         NewSubMenu({$IFNDEF RUS}'~O~ptions...'{$ELSE}'~~樨...'{$ENDIF}, hcMOptions,
           NewMenu(
             NewItem({$IFNDEF RUS}'~O~ptions...'{$ELSE}'~~樨...'{$ENDIF}, '', kbNoKey, cmDBWOptions, hcOptions,
             NewItem({$IFNDEF RUS}'~C~olors...'{$ELSE}'~~...'{$ENDIF}, '', kbNoKey, cmColors, hcMColors,
             NewLine(
             NewItem({$IFNDEF RUS}'~S~ave palette ...'{$ELSE}'~~࠭ ...'{$ENDIF}, '',
                      kbNoKey, cmSavePalette , hcMColors,
             NewItem({$IFNDEF RUS}'~L~oad palette ...'{$ELSE}'~~ ...'{$ENDIF}, '',
                      kbNoKey, cmLoadPalette, hcMColors,
             Nil)))))),
         NewLine(
         NewItem({$IFNDEF RUS}'~P~rint...'{$ELSE}'~~...'{$ENDIF}, 'F9', kbF9, cmPrint, hcPrint,
         NewLine(
         NewItem({$IFNDEF RUS}'~A~bout...'{$ELSE}' ~~...'{$ENDIF}, '', kbNoKey, cmAbout, hcAbout,
         nil)))))))))))))))))));
    P^.Options:=P^.Options or ofCentered;
  ResourseFile.Put(P, 'LocalMenu');
  Dispose(P, Done);

{$IFNDEF RUS}
  P:=New(PFileDialog, Init('*.prn','࠭ 䠩',
      '~~',fdOkButton + fdNoLoadDir+fdHelpButton, 0));
{$ELSE}
  P:=New(PFileDialog, Init('*.prn','Save file',
      'Name',fdOkButton + fdNoLoadDir+fdHelpButton, 0));
{$ENDIF}
  ResourseFile.Put(P, 'SavePrnFile');
  Dispose(P, Done);

{$IFNDEF RUS}
  P:=New(PFileDialog, init('*.dbf','஢  ...',
      '~~  䠩',fdOkButton+fdNoLoadDir+fdHelpButton, 102));
{$ELSE}
  P:=New(PFileDialog, init('*.dbf','Copy structure to...',
      '~N~ame of new file',fdOkButton+fdNoLoadDir+fdHelpButton, 102));
{$ENDIF}
  ResourseFile.Put(P, 'CopyStruct');
  Dispose(P, Done);

{$IFNDEF RUS}
  P:=New(PFileDialog, init('*.dbf','஢  ...',
      '~~  䠩',fdOkButton+fdNoLoadDir+fdHelpButton, 102));
{$ELSE}
  P:=New(PFileDialog, init('*.dbf','Copy structure to...',
      '~N~ame of new file',fdOkButton+fdNoLoadDir+fdHelpButton, 102));
{$ENDIF}
  ResourseFile.Put(P, 'DBFCreateDialog');
  Dispose(P, Done);

{$IFNDEF RUS}
  P:=New(PFileDialog, Init('*.pal',  'Save palette to file...',
      '~S~ave palette',fdOkButton+fdNoLoadDir+fdHelpButton, 141));
{$ELSE}
  P:=New(PFileDialog, Init('*.pal',  '࠭   䠩...',
      '~~࠭ ',fdOkButton+fdNoLoadDir+fdHelpButton, 141));
{$ENDIF}
  ResourseFile.Put(P, 'PalSave');
  Dispose(P, Done);

{$IFNDEF RUS}
  P:=New(PFileDialog, Init('*.dbf',  'Open database file...',
      '~D~atabase file',fdOkButton+fdNoLoadDir+fdHelpButton, 142));
{$ELSE}
  P:=New(PFileDialog, Init('*.dbf',  ' 䠩  ...',
      '~~  ',fdOkButton+fdNoLoadDir+fdHelpButton, 142));
{$ENDIF}
  ResourseFile.Put(P, 'DbfOpenDlg');
  Dispose(P, Done);
end;


procedure CreateIndexExpresDialog;
var R:TRect;
    P:PView;
    Form:PDialog;
begin
   R.Assign( 11,  7, 68, 15);
   Form:=New(PDialog,Init(R,{$IFDEF RUS}' ᭮ ࠦ'{$ELSE}'Enter index expresion'{$ENDIF}));
   with Form^ do
   begin
      HelpCtx:=hcDLGIndexExp;
      Options:=Options or ofCentered;
      R.Assign( 13,  2, 52,  3);
        P:=Insert(New(PInputLine, Init( R ,60)));
      R.Assign(  1,  2, 13,  3);
        Insert(New(PLabel, Init( R ,{$IFDEF RUS}'~~ࠦ'{$ELSE}'~E~xpresion'{$ENDIF}, P)));
      R.Assign( 52,  2, 55,  3);
        Insert(New(PHistory, Init( R ,PInputLine(P), 103)));
      R.Assign(  7,  5, 18,  7);
        Insert(New(PButton, Init( R, strOk, cmOK, bfDefault)));
      R.Assign( 18,  5, 29,  7);
        Insert(New(PButton, Init( R, strCancel, cmCancel, bfNormal)));
      R.Assign( 40,  5, 51,  7);
        Insert(New(PButton, Init( R, strHelp, cmHelp, bfNormal)));
      SelectNext(false);
   end;
  ResourseFile.Put(Form, 'IndexExpresDlg');
  Dispose(Form, Done);
end;

procedure CreateFileStruDialog;
var R:TRect;
    P:PView;
    ScrollBar:PScrollBar;
    Form:PDialog;
begin
   R.Assign( 18,  2, 67, 20);
   Form:=New(PDialog,Init(R,{$IFDEF RUS}' 䠩'{$ELSE}'File structure...'{$ENDIF}));
   with Form^ do
   begin
      Options:=Options or ofCentered;
      R.Assign(  1,  1, 48,  2);
        Insert(New(PParamText, Init( R ,{$IFDEF RUS}': %s'{$ELSE}'Version: %s'{$ENDIF},1)));
      R.Assign( 33,  2, 34, 14);
        ScrollBar:=Insert(New(PScrollBar, Init( R)));
      R.Assign( 35,  2, 47,  3);
        Insert(New(PStaticText, Init( R ,{$IFDEF RUS}'. ᥩ'{$ELSE}'Record count'{$ENDIF})));
      R.Assign(  1,  2, 33, 14);
        Insert(New(PListBox, Init( R ,1,ScrollBar)));
      R.Assign( 35,  3, 48,  4);
        Insert(New(PParamText, Init( R ,^R'%d',1)));
      R.Assign( 35,  4, 48,  6);
        Insert(New(PParamText, Init( R ,{$IFDEF RUS}' .'{$ELSE}'Record size'{$ENDIF}+^M^R'%d '
                     +{$IFDEF RUS}''{$ELSE}'byte'{$ENDIF},1)));
      R.Assign( 35,  6, 48, 8);
        Insert(New(PParamText, Init( R ,{$IFDEF RUS}':'{$ELSE}'Last update'{$ENDIF}+^M^R'%s',1)));
      R.Assign(  2, 15, 13, 17);
        Insert(New(PButton, Init( R, strOk, cmOK, bfDefault)));
      R.Assign( 13, 15, 24, 17);
        Insert(New(PButton, Init( R, strCancel, cmCancel, bfNormal)));
      R.Assign( 25, 15, 36, 17);
        Insert(New(PButton, Init( R ,{$IFDEF RUS}'~~-'{$ELSE}'~S~ave'{$ENDIF}, cmYes, bfNormal)));
      R.Assign( 36, 15, 47, 17);
        Insert(New(PButton, Init( R, strHelp, cmHelp, bfNormal)));
      SelectNext(false);
   end;
  ResourseFile.Put(Form, 'FileStruDlg');
  Dispose(Form, Done);
end;

procedure CreateAboutForm;
var R:TRect;
    Form:PDialog;
    P:PView;
begin
   R.Assign( 22,  3, 63, 18);
   Form:=New(PDialog,Init(R,{$IFDEF RUS}' '{$ELSE}'About'{$ENDIF}));
   with Form^ do
   begin
      Options:=Options or ofCentered;
      HelpCtx:=hcAboutDlg;
      R.Assign( 1,  2, 40,  3);
        Insert(New(PStaticText, Init( R ,^C+{$IFDEF RUS}'⨫ ᬮ  '
                                            {$ELSE}'Data base file viewer'{$ENDIF})));
      R.Assign( 1,  3, 40,  4);
        Insert(New(PStaticText, Init( R ,^C'(c) 1999-'+IntToStr(CurrentYear)+ {$IFDEF RUS}' 㭮 ..'
                                                                              {$ELSE}' by Lagunov A.A.'{$ENDIF})));
      R.Assign( 1,  5, 40,  6);
        Insert(New(PStaticText, Init( R,{$IFDEF RUS}^C': '{$ELSE}^C'Vers: '{$ENDIF}+Vers+OS_NAME)));
      R.Move(0,1);
        Insert(New(PStaticText, Init( R , ^C+
         {$IFDEF RUS}'ઠ '+IntToStr(BuildNo)+'  '+DateToStr(Date)
         {$ELSE}'Build '+IntToStr(BuildNo)+' from '+DateToStr(Date){$ENDIF})));
      R.Assign( 13,  9, 38, 10);
        P:=Insert(New(PColorText, Init( R ,'alexs@n10.ft.stavropol.ru', $74)));
        P^.OnMouseEvent:=LetterSend;
        P^.EventMask:=P^.EventMask or evMouseDown or evMouseUp or evMouseMove;
      R.Assign(  3,  9,  9, 11);
        Insert(New(PStaticText, Init( R ,'email: fido:')));
      R.Assign( 26, 10, 38, 11);
        Insert(New(PColorText, Init( R ,'2:5064/13.50', $71)));
      R.Assign(  2,  8, 24,  9);
        Insert(New(PStaticText, Init( R ,{$IFDEF RUS}'易  ஬'{$ELSE}'Contact with author:'{$ENDIF})));
      R.Assign( 16, 12, 26, 14);
        Insert(New(PButton, Init( R, strOk, cmOK, bfDefault)));
      SelectNext(false);
   end;
  ResourseFile.Put(Form, 'About');
  Dispose(Form, Done);
end;

procedure CreateFindForm;
var R:TRect;
    P:PView;
    Form:PDialog;
begin
   R.Assign( 16,  7, 70, 18);
   Form:=New(PDialog,Init(R,{$IFDEF RUS}'   ᪠...'{$ELSE}'Enter text to find'{$ENDIF}));
   with Form^ do
   begin
      Options:=Options or ofCentered;
      HelpCtx:=hcDLGFind;
      R.Assign( 11,  2, 49,  3);
        P:=Insert(New(PInputLine, Init( R ,255)));
      R.Assign(  1,  2, 10,  3);
        Insert(New(PLabel, Init( R ,{$IFDEF RUS}'~~祭'{$ELSE}'~T~ext'{$ENDIF}, P)));
      R.Assign( 49,  2, 52,  3);
        Insert(New(PHistory, Init( R ,PInputLine(P), 100)));
      R.Assign(  4,  5, 51,  7);
        P:=Insert(New(PCheckBoxes, Init( R ,
                  NewSItem({$IFDEF RUS}'~~  ॣ'{$ELSE}'~C~ase insensitive'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~⪮'{$ELSE}'~R~ight trim'{$ENDIF},
                  NewSItem({$IFDEF RUS}'᪠ ~~宦'{$ELSE}'~I~nclude'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~ ࢮ '{$ELSE}'~G~o first'{$ENDIF},
                  nil)))))));
      R.Assign(  1,  4, 20,  5);
        Insert(New(PLabel, Init( R ,{$IFDEF RUS}'᫮ ᪠'{$ELSE}'Options'{$ENDIF}, P)));
      R.Assign( 18,  8, 29, 10);
        Insert(New(PButton, Init( R , strOk, cmOK, bfDefault)));
      R.Assign( 29,  8, 40, 10);
        Insert(New(PButton, Init( R , strCancel, cmCancel, bfNormal)));
      R.Assign( 40,  8, 51, 10);
        Insert(New(PButton, Init( R , strHelp, cmHelp, bfNormal)));
      SelectNext(false);
   end;
  ResourseFile.Put(Form, 'FindForm');
  Dispose(Form, Done);
end;

procedure CreateGoDlg;
var R:TRect;
    P:PView;
    Form:PDialog;
begin
   R.Assign( 21,  9, 63, 17);
   Form:=New(PDialog,Init(R,{$IFDEF RUS}'  '{$ELSE}'Go record number'{$ENDIF}));
   with Form^ do
   begin
      Options:=Options or ofCentered;
      R.Assign( 16,  2, 34,  3);
        P:=Insert(New(PRangeILine, Init( R ,1, 2147483647)));
      R.Assign(  1,  2, 15,  3);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~ '{$ELSE}'~R~ecord number'{$ENDIF}, P)));
      R.Assign( 35,  2, 38,  3);
        Insert(New(PHistory, Init( R, PInputLine(P), 101)));
      R.Assign(  1,  5, 12,  7);
        Insert(New(PButton, Init( R,strOk, cmOK, bfDefault)));
      R.Assign( 12,  5, 23,  7);
        Insert(New(PButton, Init( R,strCancel, cmCancel, bfNormal)));
      R.Assign( 30,  5, 41,  7);
        Insert(New(PButton, Init( R,strHelp, cmHelp, bfNormal)));
      SelectNext(false);
   end;
  ResourseFile.Put(Form, 'GoForm');
  Dispose(Form, Done);
end;

procedure CreateDirectFieldEditorDlg;
var R:TRect;
    P:PView;
    Form:PDialog;
begin
   R.Assign( 15,  6, 70, 15);
   Form:=New(PDialog,Init(R,{$IFDEF RUS}'אַ ।஢ '{$ELSE}'Field direct editor...'{$ENDIF}));
   with Form^ do
   begin
      Options:=Options or ofCentered;
      R.Assign(  4,  1, 52,  2);
        Insert(New(PParamText, Init( R,{$IFDEF RUS}' : ''%s''.  : %d.'
                                       {$ELSE}'Field name: ''%s''. Field size: %d.'{$ENDIF},2)));
      R.Assign( 10,  3, 52,  4);
        P:=Insert(New(PInputLine, Init( R,255)));
      R.Assign(  2,  3, 10,  4);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~祭'{$ELSE}'~V~alue'{$ENDIF}, P)));
      R.Assign(  3,  6, 14,  8);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~O~k'{$ENDIF}, cmOK, bfDefault)));
      R.Assign( 23,  6, 34,  8);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'⬥'{$ELSE}'Cancel'{$ENDIF}, cmCancel, bfNormal)));
      R.Assign( 35,  6, 46,  8);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~H~elp'{$ENDIF}, cmHelp, bfNormal)));
      SelectNext(false);
   end;
  ResourseFile.Put(Form, 'DirectFieldEditor');
  Dispose(Form, Done);
end;

procedure CreatePrintDlg;
var R:TRect;
    P:PView;
    ScrollBar:PScrollBar;
    Form:PDialog;
begin
   R.Assign( 13,  1, 66, 21);
   Form:=New(PDialog,Init(R,{$IFDEF RUS}'ன ਭ...'{$ELSE}'Print setup ...'{$ENDIF}));
   with Form^ do
   begin
      Options:=Options or ofCentered;
      R.Assign( 36,  2, 37, 17);
        ScrollBar:=Insert(New(PScrollBar, Init( R)));
      R.Assign(  1,  2, 36, 17);
        P:=Insert(New(PMultiSelBox, Init( R ,1,ScrollBar, #251)));
      R.Assign(  1,  1, 20,  2);
        Insert(New(PLabel, Init( R ,{$IFDEF RUS}'~~롥 '{$ELSE}'~C~hose fields'{$ENDIF}, P)));
      R.Assign( 38, 10, 51, 12);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem('~D~os',
                  NewSItem('~W~indows',
                  nil)))));
      R.Assign( 37,  9, 49, 10);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}' ࠭'{$ELSE}'Codepage'{$ENDIF}, P)));
      R.Assign( 38, 13, 51, 16);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem({$IFDEF RUS}'~~'{$ELSE}'~N~one'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~பa'{$ELSE}'~L~ine'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~'{$ELSE}'~R~ecord'{$ENDIF},
                  nil))))));
      R.Assign( 37,  12, 49, 13);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}'㬥'{$ELSE}'Line number'{$ENDIF}, P)));
      R.Assign(  1, 18, 49, 19);
        P:=Insert(New(PInputLine, Init( R ,255)));
      R.Assign( 49, 18, 52, 19);
        Insert(New(PHistory, Init( R , PInputLine(P), 121)));
      R.Assign(  1, 17, 30, 18);
        Insert(New(PLabel, Init( R ,{$IFDEF RUS}'~~ ᫮ 䨫'{$ELSE}'~E~nter record filter'{$ENDIF}, P)));
      R.Assign( 38,  2, 49,  4);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~O~k'{$ENDIF}, cmOK, bfDefault)));
      R.Assign( 38,  4, 49,  6);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'⬥'{$ELSE}'Cancel'{$ENDIF}, cmCancel, bfNormal)));
      SelectNext(false);
   end;
  ResourseFile.Put(Form, 'PrintDlg');
  Dispose(Form, Done);
end;

procedure CreateColorSel;
var D:PColorDialog;
begin
  D := New(PColorDialog, Init('',
    ColorGroup({$IFDEF RUS}''{$ELSE}'Menus'{$ENDIF},         MenuColorItems(nil),
    ColorGroup({$IFDEF RUS}''{$ELSE}'Dialogs'{$ENDIF},  DialogColorItems(dpGrayDialog, nil),
    ColorGroup({$IFDEF RUS}''{$ELSE}'Grids'{$ENDIF},  DialogColorItems(dpBlueDialog, nil),
    ColorGroup({$IFDEF RUS}''{$ELSE}'Froms'{$ENDIF},  DialogColorItems(dpCyanDialog, nil),
      nil))))));
  D^.HelpCtx := hcColorsDBox;
  ResourseFile.Put(D, 'ColorDlg');
  Dispose(D, Done);
end;

procedure CreateStartUpDlg;
var R:TRect;
    TabbedNotebook1:PTabbedNotebook;
    P:PView;
    Form:PDialog;
const
  SSystemPage  = {$IFDEF RUS}'~~⥬'  {$ELSE}'S~y~stem'  {$ENDIF};
  SDisplayPage = {$IFDEF RUS}'~~࠭'    {$ELSE}'~D~isplay' {$ENDIF};
  SStartUPPage = {$IFDEF RUS}'~~㧪' {$ELSE}'StartU~P~' {$ENDIF};
  SColorsPage  = {$IFDEF RUS}'~~'  {$ELSE}'Pa~l~ette' {$ENDIF};
begin
   R.Assign( 15,  2, 69, 19);
   Form:=New(PDialog,Init(R,{$IFDEF RUS}'樨'{$ELSE}'Options'{$ENDIF}));
   with Form^ do
   begin
      Options:=Options or ofCentered;
      R.Assign(1,1,53,4);
        TabbedNotebook1:=Insert(New(PTabbedNotebook, Init(R)));
      R.Assign(  3,  5, 21,  8);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem({$IFDEF RUS}'~~ '{$ELSE}'~N~o cliboard'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~⠭'{$ELSE}'~S~tandart'{$ENDIF},
                  NewSItem('~W~indows',
                  nil))))));
        TabbedNotebook1^.AddToPage(SSystemPage, P);
        TabbedNotebook1^.PageByName(SSystemPage)^.CurSelect:=P;
      R.Assign(  1,  4, 20,  5);
        P:=Insert(New(PLabel, Init( R ,{$IFDEF RUS}'~~ '{$ELSE}'Clipboard'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SSystemPage, P);
      R.Assign( 26,  5, 46,  8);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem({$IFDEF RUS}'~~'{$ELSE}'~A~utodetect'{$ENDIF},
                  NewSItem('Dos ~8~66',
                  NewSItem('Windows ~1~251',
                  nil))))));
        TabbedNotebook1^.AddToPage(SSystemPage, P);
      R.Assign( 24,  4, 43,  5);
        P:=Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~砫쭠  ࠭'{$ELSE}'Startup code page'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SSystemPage, P);
      R.Assign(  3, 9, 25, 12);
        P:=Insert(New(PCheckBoxes, Init( R ,
                  NewSItem({$IFDEF RUS}'~~࠭⥫ ࠭'{$ELSE}'~U~se screen saver'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~  ⮩ ப'{$ELSE}'Run e~m~pty cmd'{$ENDIF},
                  NewSItem({$IFDEF RUS}'⮮'{$ELSE}'Auto re~f~resh'{$ENDIF},
                  nil))))));
        TabbedNotebook1^.AddToPage(SSystemPage, P);
        P^.HelpCtx:=hcScreenSaver;
      R.Assign( 15, 12, 25, 13);
        P:=Insert(New(PRangeILine, Init( R , 0, 60)));
        P^.HelpCtx:=hcScreenSaver;
        TabbedNotebook1^.AddToPage(SSystemPage, P);
      R.Assign(  4, 12, 14, 13);
        P:=Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~ࢠ'{$ELSE}'~I~nterval'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SSystemPage, P);

      R.Assign(  26, 10, 48, 11);
        P:=Insert(New(PCheckBoxes, Init( R ,
                  NewSItem({$IFDEF RUS}'~~ ०'{$ELSE}'~E~xclusive mode'{$ENDIF},
                  nil))));
        TabbedNotebook1^.AddToPage(SSystemPage, P);
        P^.HelpCtx:=hcExclusiveFile;
      R.Assign(  26, 12, 51, 13);
       P:=Insert(New(PLockUpInputLine, Init( R ,
                 NewSItem({$IFDEF RUS}'()'{$ELSE}'(None)'{$ENDIF},
                 NewSItem('DBase II',
                 NewSItem('DBase III Plus',
                 NewSItem('DBase IV',
                 NewSItem({$IFDEF RUS}'DBase  Windows'{$ELSE}'DBase for Windows'{$ENDIF},
                 NewSItem({$IFDEF RUS}'Foxpro  Dos'{$ELSE}'Foxpro for Dos'{$ENDIF},
                 NewSItem({$IFDEF RUS}'Foxpro  Windows'{$ELSE}'Foxpro for Windows'{$ENDIF},
                 NewSItem('DBase VII',
                 NewSItem('Visual FoxPro',
                 nil))))))))))));
        TabbedNotebook1^.AddToPage(SSystemPage, P);
        P^.HelpCtx:=hcExclusiveFile;
      R.Assign(  26, 11, 51, 12);
        P:=Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~ࠩ  㬮砭'{$ELSE}'Default d~r~iver'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SSystemPage, P);

      R.Assign( 2,  4, 23,  7);
        P:=Insert(New(PCheckBoxes, Init( R ,
                  NewSItem({$IFDEF RUS}'~~뢠 MEMO'{$ELSE}'Sho~w~ memo value'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~ '{$ELSE}'~S~ystem fields'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~ '{$ELSE}'~R~ecord number'{$ENDIF},
                  nil))))));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
        TabbedNotebook1^.PageByName(SDisplayPage)^.CurSelect:=P;
      R.Assign( 42,  4, 52,  5);
        P:=Insert(New(PInputLine, Init( R ,10)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 23,  4, 42,  5);
        P:=Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~  MEMO'{$ELSE}'~D~isplay text memo'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);

      R.Assign(  9, 7, 20, 8);
        P:=Insert(New(PInputLine, Init( R ,10)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign(  1, 7,  8, 8);
        P:=Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'T~r~ue'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 30, 7, 40, 8);
        P:=Insert(New(PInputLine, Init( R ,10)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 24, 7, 30, 8);
        P:=Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~F~alse'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);

      R.Assign(  3,  9, 21, 12);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem({$IFDEF RUS}'~~'{$ELSE}'~G~raph'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~⠭'{$ELSE}'S~t~andart'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~'{$ELSE}'~M~anual'{$ENDIF},
                  nil))))));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign(  1,  8, 20,  9);
        P:=Insert(New(PLabel, Init( R,{$IFDEF RUS}''{$ELSE}'Frames'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign(  3, 12, 21, 13);
        P:=Insert(New(PCheckBoxes, Init( R ,
                  NewSItem({$IFDEF RUS}'~~ ࠬ'{$ELSE}'F~u~ll frames'{$ENDIF},
                  nil))));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);

      R.Assign( 25,  9, 47, 12);
        P:=Insert(New(PStaticText, Init( R,'S')));
        P^.Options:=P^.Options or ofFramed;
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 37,  9, 46, 10);
        P:=Insert(New(PInputLine, Init( R,1)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 25,  9, 37, 10);
        P:=Insert(New(PLabel, Init( R ,{$IFDEF RUS}'~~⠫쭮'{$ELSE}'Horizanta~l~'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 37, 10, 46, 11);
        P:=Insert(New(PInputLine, Init( R ,1)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 25, 10, 37, 11);
        P:=Insert(New(PLabel, Init( R ,{$IFDEF RUS}'~~⨪쭮'{$ELSE}'~V~ertical'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 37, 11, 46, 12);
        P:=Insert(New(PInputLine, Init( R ,1)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 25, 11, 37, 12);
        P:=Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'C~e~nter'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);
      R.Assign( 25,  8, 35,  9);
        P:=Insert(New(PStaticText, Init( R,{$IFDEF RUS}'...'{$ELSE}'Frames...'{$ENDIF})));
        TabbedNotebook1^.AddToPage(SDisplayPage, P);

      R.Assign(  49,  5, 50,  13);
        P:=Insert(New(PScrollBar, Init(R)));
        TabbedNotebook1^.AddToPage(SStartUPPage, P);
      R.Assign(  3,  5, 49,  13);
        P:=Insert(New(PListBox, Init( R , 1, PScrollBar(P))));
        P^.HelpCtx:=hcSel_Lang;
        TabbedNotebook1^.AddToPage(SStartUPPage, P);
      R.Assign( 1,  4, 20,  5);
        P:=Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~L~anguage'{$ENDIF}, P)));
        TabbedNotebook1^.AddToPage(SStartUPPage, P);

        TabbedNotebook1^.SelectPage(0);
      R.Assign(  8, 14, 19, 16);
        Insert(New(PButton, Init( R, strOk, cmOK, bfDefault)));
      R.Assign( 23, 14, 34, 16);
        Insert(New(PButton, Init( R, strCancel, cmCancel, bfNormal)));
      R.Assign( 37, 14, 48, 16);
        Insert(New(PButton, Init( R, strHelp, cmHelp, bfNormal)));
      SelectNext(false);
   end;
   ResourseFile.Put(Form, 'OptionsDlg');
   Dispose(Form, Done);
end;

procedure CreateFileCreateBoxs;
var D:PDialog;
    R:TRect;
    P:PView;
    ScrollBar:PScrollBar;
begin
   R.Assign( 19,  5, 65, 17);
   D:=New(PDialog,Init(R,' '));
   with D^ do
   begin
      Options:=Options or ofCentered;
      R.Assign(  3,  2, 18,  3);
        P:=Insert(New(PInputLine, Init( R ,10)));
        PInputLine(P)^.SetValidator(New(PPXPictureValidator, Init('?[@[@[@[@[@[@[@[@[@]]]]]]]]]',false)));
      R.Assign(  1,  1,  6,  2);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~N~ame'{$ENDIF}, P)));
      R.Assign( 21,  2, 31,  3);
        P:=Insert(New(PRangeILine, Init( R ,1, 255)));
      R.Assign( 19,  1, 27,  2);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~L~ength'{$ENDIF}, P)));
      R.Assign( 34,  2, 41,  3);
        P:=Insert(New(PRangeILine, Init( R ,0, 10)));
      R.Assign( 32,  1, 38,  2);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~D~ec'{$ENDIF}, P)));
      R.Assign(  3,  4, 41,  7);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem({$IFDEF RUS}'~~ப'{$ELSE}'~C~haracter'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~᫮'{$ELSE}'~I~nteger'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~'{$ELSE}'~D~ate'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~.'{$ELSE}'~L~ogical'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~'{$ELSE}'~F~loat'{$ENDIF},
                  NewSItem({$IFDEF RUS}'~~ਬ砭'{$ELSE}'~M~emo'{$ENDIF},
                  nil)))))))));
      P^.Options:=P^.Options or ofFramed;
      PRadioButtons(P)^.EnableMask:=$2F;
      R.Assign(  1,  3,  7,  4);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~T~ype'{$ENDIF}, P)));
      R.Assign(  3,  9, 14, 11);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~O~k'{$ENDIF}, cmOK, bfDefault)));
      R.Assign( 15,  9, 26, 11);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'⬥'{$ELSE}'Cancel'{$ENDIF}, cmCancel, bfNormal)));
      R.Assign( 28,  9, 39, 11);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE} '~H~elp'{$ENDIF}, cmHelp, bfNormal)));
      SelectNext(false);
   end;
   ResourseFile.Put(D, 'NewDBFieldDialog');
   Dispose(D, Done);

   R.Assign( 15,  2, 67, 19);
   D:=New(PDialog, Init(R,' '));
   with D^ do
   begin
     Options:=Options or ofCentered;
     HelpCtx:=hcRestTable;
     R.Assign( 36,  2, 37, 13);
       ScrollBar:=Insert(New(PScrollBar, Init( R)));
     R.Assign(  1,  2, 36, 13);
       P:=Insert(New(PListBox, Init( R ,1, ScrollBar)));
       P^.EventMask:=P^.EventMask or evCommand;
       P^.OnCmdEvent:=CreateTableDialog_HandleEvent;
     R.Assign(  1,  1, 36,  2);
       Insert(New(PLabel, Init( R ,{$IFDEF RUS}'~~        |||.'{$ELSE}
                    '~N~ame       |Typ|Length|Dec.  '{$ENDIF}, P)));
     R.Assign(  4, 14, 32, 15);
       P:=Insert(New(PLockUpInputLine, Init( R ,
                 NewSItem('DBase II',
                 NewSItem('DBase III Plus',
                 NewSItem('DBase IV',
                 NewSItem({$IFDEF RUS}'DBase  Windows'{$ELSE}'DBase for Windows'{$ENDIF},
                 NewSItem({$IFDEF RUS}'Foxpro  Dos'{$ELSE}'Foxpro for Dos'{$ENDIF},
                 NewSItem({$IFDEF RUS}'Foxpro  Windows'{$ELSE}'Foxpro for Windows'{$ENDIF},
                 NewSItem('DBase VII',
                 NewSItem('Visual FoxPro',
                 nil)))))))))));
     R.Assign(  1, 13, 20, 14);
       Insert(New(PLabel, Init( R ,'~~ ⠡', P)));
     R.Assign( 38,  1, 49,  3);
       Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~O~k'{$ENDIF}, cmOK, bfDefault)));
     R.Assign( 38,  3, 49,  5);
       Insert(New(PButton, Init( R,{$IFDEF RUS}'⬥'{$ELSE}'Cancel'{$ENDIF}, cmCancel, bfNormal)));
     R.Assign( 38,  7, 50,  9);
       Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~A~dd'{$ENDIF}, cmFAdd, bfNormal)));
     R.Move(0,2);
       Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~D~ell'{$ENDIF}, cmFDel, bfNormal)));
     R.Move(0,2);
       Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~E~dit'{$ENDIF}, cmFEdit, bfNormal)));
     R.Assign( 38, 14, 49, 16);
       Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE} '~H~elp'{$ENDIF}, cmHelp, bfNormal)));
     SelectNext(false);
   end;
   ResourseFile.Put(D, 'CreateTableDialog');
   Dispose(D, Done);

   R.Assign( 16,  6, 68, 16);
   D:=New(PDialog,Init(R,{$IFDEF RUS}'࠭ '{$ELSE}'Range editor'{$ENDIF}));
   with D^ do
   begin
      Options:=Options or ofCentered;
      R.Assign( 11,  2, 47,  3);
        P:=Insert(New(PInputLine, Init( R, 255)));
      R.Assign(  2,  2, 11,  3);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'H~i~'{$ENDIF}, P)));
      R.Assign( 47,  2, 50,  3);
        Insert(New(PHistory, Init( R, PInputLine(P), 106)));
      R.Assign( 11,  4, 47,  5);
        P:=Insert(New(PInputLine, Init( R, 255)));
      R.Assign(  2,  4, 10,  5);
        Insert(New(PLabel, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~L~o'{$ENDIF}, P)));
      R.Assign( 47,  4, 50,  5);
        Insert(New(PHistory, Init( R ,PInputLine(P), 106)));
      R.Assign( 14,  7, 25,  9);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE}'~O~k'{$ENDIF}, cmOK, bfDefault)));
      R.Assign( 25,  7, 36,  9);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'⬥'{$ELSE}'Cancel'{$ENDIF}, cmCancel, bfNormal)));
      R.Assign( 38,  7, 49,  9);
        Insert(New(PButton, Init( R,{$IFDEF RUS}'~~'{$ELSE} '~H~elp'{$ENDIF}, cmHelp, bfNormal)));
      SelectNext(false);
   end;
   ResourseFile.Put(D, 'RangeDialog');
   Dispose(D, Done);
end;

procedure CreateFillDialog;
var ReplaseForm:PDialog;
    DBEdit1:PDBEdit;
    R:TRect;
    P:PView;
begin
   R.Assign( 11,  6, 69, 14);
   ReplaseForm:=New(PDialog,Init(R,
    {$IFDEF RUS}'  '{$ELSE}'Replase all records'{$ENDIF}));
   with ReplaseForm^ do
   begin
      Options:=Options or ofCentered;
      R.Assign(  4,  2, 53,  3);
        Insert(New(PParamText, Init( R ,
              {$IFDEF RUS}'  %s   '
              {$ELSE}'Fill field %s in all records'{$ENDIF},1)));
      R.Assign( 10,  3, 54,  4);
        DBEdit1:=Insert(New(PDBEdit, Init( R ,nil, '')));
        AssignStr(DBEdit1^.ComponentName,'DBEdit1');
      R.Assign(  3,  3,  9,  4);
        Insert(New(PLabel, Init( R ,{$IFDEF RUS}'~~祭'{$ELSE}'~V~alue'{$ENDIF}, DBEdit1)));
      R.Assign( 54,  3, 57,  4);
        Insert(New(PHistory, Init( R ,DBEdit1,111)));
      R.Assign( 21,  5, 32,  7);
        Insert(New(PButton, Init( R , strOk, cmOK, bfDefault)));
      R.Assign( 32,  5, 43,  7);
        Insert(New(PButton, Init( R , strCancel, cmCancel, bfNormal)));
      R.Assign( 45,  5, 56,  7);
        Insert(New(PButton, Init( R , strHelp, cmHelp, bfNormal)));
      SelectNext(false);
   end;
   ResourseFile.Put(ReplaseForm, 'ReplaseForm');
   Dispose(ReplaseForm, Done);
end;

procedure CreateFilterDialog;
var Form9:PDialog;
    DBEdit1:PDBEdit;
    R:TRect;
    P:PView;
begin
   R.Assign(  8,  6, 70, 14);
   Form9:=New(PDialog,Init(R,{$IFDEF RUS}''{$ELSE}'Filter'{$ENDIF}));
   with Form9^ do
   begin
      Options:=Options or ofCentered;
      R.Assign(  2,  3, 58,  4);
        P:=Insert(New(PInputLine, Init( R ,255)));
      R.Assign(  2,  2, 44,  3);
        Insert(New(PLabel, Init( R, {$IFDEF RUS}'~~ ࠦ  䨫樨'
                                         {$ELSE}'~E~nter filter expression'{$ENDIF}, P)));
      R.Assign( 58,  3, 61,  4);
        Insert(New(PHistory, Init( R , PInputLine(P), 121)));
      R.Assign( 23,  5, 34,  7);
        Insert(New(PButton, Init( R , strOk, cmOK, bfDefault)));
      R.Assign( 34,  5, 45,  7);
        Insert(New(PButton, Init( R , strCancel, cmCancel, bfNormal)));
      R.Assign( 49,  5, 60,  7);
        Insert(New(PButton, Init( R , strHelp, cmHelp, bfNormal)));
      SelectNext(false);
   end;
   ResourseFile.Put(Form9, 'FilterForm');
   Dispose(Form9, Done);
end;

procedure CreateSelectLngDlg;
var
    Form:PDialog;
function CreateDlg(const AName:string):PDialog;
var R:TRect;
    Button3:PButton;
    ListBox1:PListBox;
    ScrollBar1:PScrollBar;
    Button2:PButton;
    Button1:PButton;
    Form1:PDialog;
begin
   R.Assign( 18,  3, 63, 17);
   Form1:=New(PDialog,Init( R, AName));
   with Form1^ do
   begin
      Options:=Options or ofCentered;
      R.Assign( 43,  1, 44, 10);
        ScrollBar1:=New(PScrollBar, Init( R));
        Insert(ScrollBar1);
      R.Assign(  1,  1, 43, 10);
        ListBox1:=New(POkListBox, Init( R ,1, ScrollBar1));
        Insert(ListBox1);
      R.Assign( 10, 11, 21, 13);
        Button1:=New(PButton, Init( R , strOk, cmOK, bfDefault));
        Insert(Button1);
      R.Assign( 21, 11, 32, 13);
        Button2:=New(PButton, Init( R , strCancel, cmCancel, bfNormal));
        Insert(Button2);
      R.Assign( 32, 11, 43, 13);
        Button3:=New(PButton, Init( R , strHelp, cmHelp, bfNormal));
        Insert(Button3);
      SelectNext(false);
   end;
   CreateDlg:=Form1;
end;
begin
  Form:=CreateDlg({$IFDEF RUS}' 몮 ࠩ'{$ELSE}'Select langvidge driver'{$ENDIF});
  ResourseFile.Put(Form, 'SelectLng');
  Dispose(Form, Done);
  Form:=CreateDlg({$IFDEF RUS}'몮 ࠩ  ४஢'{$ELSE}'Langvidge driver for recoding'{$ENDIF});
  ResourseFile.Put(Form, 'SelectLngForDLG');
  Dispose(Form, Done);
end;

procedure CreateQueryDelete;
var R:TRect;
    InputLine1:PInputLine;
    Form2:PDialog;
begin
   R.Assign( 10,  6, 70, 15);
   Form2:=New(PDialog,Init(R, {$IFNDEF RUS}'Enter delete query expresion'
                              {$ELSE}' ᫮ 㤠'{$ENDIF}));
   with Form2^ do
   begin
      Options:=Options or ofCentered;
      R.Assign(  2,  2, 59,  4);
        Insert(New(PParamText, Init( R ,'DELETE'#13'FROM "%s"',1)));
      R.Assign(  8,  4, 55,  5);
        InputLine1:=Insert(New(PInputLine, Init( R ,255)));
      R.Assign(  1,  4,  7,  5);
        Insert(New(PLabel, Init( R ,'~W~HERE', InputLine1)));
      R.Assign( 55,  4, 58,  5);
        Insert(New(PHistory, Init( R , InputLine1, 140)));
      R.Assign( 25,  6, 36,  8);
        Insert(New(PButton, Init( R , strOk, cmOK, bfDefault)));
      R.Assign( 36,  6, 47,  8);
        Insert(New(PButton, Init( R , strCancel, cmCancel, bfNormal)));
      R.Assign( 47,  6, 58,  8);
        Insert(New(PButton, Init( R , strHelp, cmHelp, bfNormal)));
      SelectNext(false);
   end;
   ResourseFile.Put(Form2, 'QueryDelete');
   Dispose(Form2, Done);
end;

procedure CreateSortSlecetDialog;
var R:TRect;
    RadioButtons:PRadioButtons;
    ScrollBar:PScrollBar;
    Form3:PDialog;
begin
   R.Assign( 17,  2, 54, 19);
   Form3:=New(PDialog,Init(R,{$IFNDEF RUS}'Select field'{$ELSE}'롮 '{$ENDIF}));
   with Form3^ do
   begin
      Options:=Options or ofCentered;
      R.Assign( 36,  1, 37, 11);
        ScrollBar:=Insert(New(PScrollBar, Init( R)));
      R.Assign(  1,  1, 36, 11);
        Insert(New(PListBox, Init( R ,1, ScrollBar)));
      R.Assign(  2, 12, 35, 13);
        RadioButtons:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem({$IFNDEF RUS}'~a~scending'{$ELSE}'~~⠭'{$ENDIF},
                  NewSItem({$IFNDEF RUS}'~d~escending'{$ELSE}'~~뢠'{$ENDIF},
                  nil)))));
      R.Assign(  1, 11,  5, 12);
        Insert(New(PLabel, Init( R ,'~~', RadioButtons)));
      R.Assign( 14, 14, 25, 16);
        Insert(New(PButton, Init( R , strOk, cmOK, bfDefault)));
      R.Assign( 25, 14, 36, 16);
        Insert(New(PButton, Init( R , strCancel, cmCancel, bfNormal)));
      SelectNext(false);
   end;
   ResourseFile.Put(Form3, 'SelectFSort');
   Dispose(Form3, Done);
end;

procedure CreateArifmetProgrDialog;
var
    Form5:PDialog;
function NewForm5:PDialog;
var R:TRect;
    HelpBtn:PButton;
    CancelBtn:PButton;
    OkBtn:PButton;
    CountEdit:PRangeILine;
    DirectionEdit:PRadioButtons;
    OptionsEdit:PRadioButtons;
    IncrementEdit:PRangeILine;
    TypeProgers:PRadioButtons;
    FirstValueEdit:PRangeILine;
    Label6:PLabel;
    History3:PHistory;
    History2:PHistory;
    History1:PHistory;
    Label5:PLabel;
    Label4:PLabel;
    Label3:PLabel;
    Label2:PLabel;
    Label1:PLabel;
    Form5:PDialog;
begin
   R.Assign( 13,  4, 61, 18);
   Form5:=New(PDialog,Init(R,{$IFDEF RUS}'ண'{$ELSE}'Progession'{$ENDIF}));
   with Form5^ do
   begin
      R.Assign( 14,  2, 25,  3);
        FirstValueEdit:=New(PRangeILine, Init( R ,-2147483647, 2147483647));
        Insert(FirstValueEdit);
      R.Assign( 31,  2, 46,  4);
        TypeProgers:=New(PRadioButtons, Init( R ,
                  NewSItem({$IFNDEF RUS}'~A~rifmetic'{$ELSE}'~~䬥᪠'{$ENDIF},
                  NewSItem({$IFNDEF RUS}'~G~eometric'{$ELSE}'~~᪠'{$ENDIF},
                  nil))));
        Insert(TypeProgers);
      R.Assign( 14,  4, 25,  5);
        IncrementEdit:=New(PRangeILine, Init( R ,-2147483647, 2147483647));
        Insert(IncrementEdit);
      R.Assign(  3,  6, 29, 10);
        OptionsEdit:=New(PRadioButtons, Init( R ,
                  NewSItem({$IFNDEF RUS}'A~l~l range'{$ELSE}'~~ '{$ENDIF},
                  NewSItem({$IFNDEF RUS}'From first ~t~o curent'{$ELSE}'~~砫  '{$ENDIF},
                  NewSItem({$IFNDEF RUS}'From curent to ~e~nd'{$ELSE}'~~  '{$ENDIF},
                  NewSItem({$IFNDEF RUS}'~O~nly count:'{$ELSE}'~~⢮'{$ENDIF},
                  nil))))));
        Insert(OptionsEdit);
      R.Assign( 31,  6, 46,  8);
        DirectionEdit:=New(PRadioButtons, Init( R ,
                  NewSItem({$IFNDEF RUS}'For~v~ard'{$ELSE}'~~'{$ENDIF},
                  NewSItem({$IFNDEF RUS}'~B~ackvard'{$ELSE}'~~'{$ENDIF},
                  nil))));
        Insert(DirectionEdit);
      R.Assign( 31,  9, 43, 10);
        CountEdit:=New(PRangeILine, Init( R ,-2147483647, 2147483647));
        Insert(CountEdit);
      R.Assign( 14, 11, 25, 13);
        OkBtn:=New(PButton, Init( R , strOk, cmOK, bfDefault));
        Insert(OkBtn);
      R.Assign( 25, 11, 36, 13);
        CancelBtn:=New(PButton, Init( R , strCancel, cmCancel, bfNormal));
        Insert(CancelBtn);
      R.Assign( 36, 11, 47, 13);
        HelpBtn:=New(PButton, Init( R , strHelp, cmHelp, bfNormal));
        Insert(HelpBtn);
      R.Assign(  1,  2, 14,  3);
        Label1:=New(PLabel, Init( R ,{$IFNDEF RUS}'~F~irst value'{$ELSE}'~~ࢮ .'{$ENDIF}, FirstValueEdit));
        Insert(Label1);
      R.Assign(  1,  4, 12,  5);
        Label2:=New(PLabel, Init( R ,{$IFNDEF RUS}'~I~ncrement'{$ELSE}'~~'{$ENDIF}, IncrementEdit));
        Insert(Label2);
      R.Assign( 29,  5, 41,  6);
        Label3:=New(PLabel, Init( R ,{$IFNDEF RUS}'Direction'{$ELSE}'ࠢ'{$ENDIF}, DirectionEdit));
        Insert(Label3);
      R.Assign(  1,  5, 10,  6);
        Label4:=New(PLabel, Init( R ,{$IFNDEF RUS}'Options'{$ELSE}'樨'{$ENDIF}, OptionsEdit));
        Insert(Label4);
      R.Assign( 29,  8, 36,  9);
        Label5:=New(PLabel, Init( R ,{$IFNDEF RUS}'~C~ount'{$ELSE}'~~-'{$ENDIF}, CountEdit));
        Insert(Label5);
      R.Assign( 25,  2, 28,  3);
        History1:=New(PHistory, Init( R ,FirstValueEdit, 150));
        Insert(History1);
      R.Assign( 43,  9, 46, 10);
        History2:=New(PHistory, Init( R ,CountEdit, 151));
        Insert(History2);
      R.Assign( 25,  4, 28,  5);
        History3:=New(PHistory, Init( R ,IncrementEdit, 152));
        Insert(History3);
      R.Assign( 29,  1, 41,  2);
        Label6:=New(PLabel, Init( R ,{$IFNDEF RUS}'Type progession'{$ELSE}' ண'{$ENDIF}, nil));
        Insert(Label6);
      SelectNext(false);
   end;
   NewForm5:=Form5;
end;
begin
   Form5:=NewForm5;
   ResourseFile.Put(Form5, 'ArifmetForm');
   Dispose(Form5, Done);
   Form5:=NewForm6;
   ResourseFile.Put(Form5, 'SelFForm');
   Dispose(Form5, Done);
end;

var
  B:TDosStream;
begin
  B.Init('Build.dat',stOpen);
  B.Read(BuildNo, SizeOf(Longint));
{$IFNDEF RUS}
{$IFNDEF VER70}
  Inc(BuildNo);
  B.Seek(0);
  B.Write(BuildNo, SizeOf(Longint));
{$ENDIF}
{$ENDIF RUS}
  B.Done;
  writeln('Resurse maker for DBViews.EXE.');
  RegisterObjects;
  RegisterViews;
  RegisterDialogs;
  RegisterTabNotbk;
  RegisterClases;
  RegisterMenus;
  RegisterValidate;
  RegisterType(RStrListMaker);
  RegisterType(RRangeILine);
  RegisterType(RHCStatusLine);
  RegisterType(RFileInputLine);
  RegisterType(RFileCollection);
  RegisterType(RFileList);
  RegisterType(RFileInfoPane);
  RegisterType(RFileDialog);
  RegisterType(RColorText);
  RegisterType(RDBEdit);
  RegisterType(ROkListBox);
  RegistersMultiSelect;
  RegisterColorSel;
  RegisterAll;
{$IFDEF RUS}
  ResourseStream := New(PProtectedStream, Init(ExePath+'DBV_RUS.LNG', stCreate));
{$ELSE}
  ResourseStream := New(PProtectedStream, Init(ExePath+'DBViews.TVR', stCreate));
{$ENDIF}
  ResourseFile.Init(ResourseStream);
  CreateStrings;
  CreateStartUpDlg;
  CreateStatusLine;
  CreateFileStruDialog;
  CreateAboutForm;
  CreateFindForm;
  CreateGoDlg;
  CreateDirectFieldEditorDlg;
  CreateIndexExpresDialog;
  CreatePrintDlg;
  CreateColorSel;
  CreateFileCreateBoxs;
  CreateFillDialog;
  CreateFilterDialog;
  CreateSelectLngDlg;
  CreateQueryDelete;
  CreateSortSlecetDialog;
  CreateArifmetProgrDialog;

  ResourseFile.Done;
{$IFDEF RUS}
  writeln('⮢.');
{$ELSE}
  writeln('Ok.');
{$ENDIF}
end.
