unit Win32func;
interface

function IsNotification:boolean;
procedure InitNotyfy(AFileName:string);
procedure StopNotification;

implementation
uses DBWind, Windows, Ext_DOs, Dos;

type
  TCriticalSection = TRTLCriticalSection;

var
  FileChanging : TCriticalSection;
  fIsNotify:boolean = false;
  HandleInstaled : boolean = false;
  HandleExit : boolean = false;
  NotifyThreadHandle : Handle;
  NotifyHandle       : Handle;
  EventThreadID      : DWord;
  FileName           : string;
  OldSize            : Longint;

function IsNotification:boolean;
begin
  if HandleInstaled then
  begin
    EnterCriticalSection(FileChanging);
    Result:=fIsNotify;
    fIsNotify:=false;
    with DBWindow^.Table^ do
      OldSize:=FileHeader^.HeaderSize+RecordCount*FileHeader^.RecordSize;
    LeaveCriticalSection(FileChanging);
  end
  else Result:=false;
end;

function EventHandleThread(p : pointer) : DWord;StdCall;
var S:SearchRec;
begin
  while not (HandleExit) do
  begin
    WaitForSingleObject(NotifyHandle, INFINITE);
    FindFirst(FileName, AnyFile, S);
    EnterCriticalSection(FileChanging);
    fIsNotify:=S.Size<>OldSize;
    FindClose(S);
    LeaveCriticalSection(FileChanging);
    FindNextChangeNotification(NotifyHandle);
  end;
end;

procedure InitNotyfy(AFileName:string);
begin
  if HandleInstaled then exit;
  InitializeCriticalSection(FileChanging);
  FileName:=FExpand(AFileName);
  AFileName:=ExtractPath(FileName);
  if FileName[Length(AFileName)]='\' then
    Delete(AFileName, Length(AFileName), 1);
  AFileName:=AFileName+#0;
  NotifyHandle:=FindFirstChangeNotification( @AFileName[1], false,
    FILE_NOTIFY_CHANGE_SIZE or FILE_NOTIFY_CHANGE_LAST_WRITE);
  NotifyThreadHandle:=CreateThread(nil,0, @EventHandleThread, nil, 0, EventThreadID);
  HandleInstaled:=true;
end;

procedure StopNotification;
begin
  if HandleInstaled then
  begin
    HandleExit:=true;
    TerminateThread(NotifyThreadHandle, 0);
//    WaitForSingleObject(NotifyThreadHandle,INFINITE);
//    CloseHandle(NotifyThreadHandle);
    FindCloseChangeNotification(NotifyHandle);
    HandleInstaled:=false;
    DeleteCriticalSection(FileChanging);
  end;
end;

initialization
finalization
  StopNotification;
end.
